/*
*/

#import <Foundation/NSAutoreleasePool.h>
#import <AppKit/AppKit.h>
#import <AppKit/NSPopUpButton.h>

@interface buttonsController : NSObject
{
  NSWindow *win;
}

@end

@implementation buttonsController

- (void)buttonAction:(id)sender
{
   if ([sender respondsToSelector:@selector(indexOfSelectedItem)])
     NSLog (@"buttonAction: sender = %@ index = %d", sender, [sender indexOfSelectedItem]);
   else
     NSLog (@"buttonAction: sender = %@", sender);
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
  NSRect wf = {{100, 100}, {400, 200}};
  NSPopUpButton *pushb;
  unsigned int style = NSTitledWindowMask | NSClosableWindowMask
		      | NSMiniaturizableWindowMask | NSResizableWindowMask;
  int	i;

  win = [[NSWindow alloc] initWithContentRect:wf
				    styleMask:style
				      backing:NSBackingStoreRetained
					defer:NO];

  /* pop up with NSPopUpButton action */
  pushb = [[NSPopUpButton alloc] initWithFrame:NSMakeRect(15,175,150,20)
                                     pullsDown:NO];
  for (i=0; i<5; i++)
    {
      [pushb addItemWithTitle:[NSString stringWithFormat:@"PopUpButton action %d", i]];
    }
  [pushb setTarget:self];
  [pushb setAction:@selector(buttonAction:)];
  [[win contentView] addSubview:pushb];

  /* pop up with NSMenuItem action */
  pushb = [[NSPopUpButton alloc] initWithFrame:NSMakeRect(200,175,150,20)];
  for (i=0; i<5; i++)
    {
      [pushb addItemWithTitle:[NSString stringWithFormat:@"MenuItem action %d", i]];
      [[pushb itemAtIndex:i] setTarget:self];
      [[pushb itemAtIndex:i] setAction:@selector(buttonAction:)];
    }
  //[pushb setTarget:self];
  //[pushb setAction:@selector(buttonAction:)];
  [[win contentView] addSubview:pushb];

  [win display];
  [win orderFront:nil];
}

@end

int
main(int argc, char **argv, char** env)
{
  id pool = [NSAutoreleasePool new];
  NSApplication *theApp;

#if LIB_FOUNDATION_LIBRARY
  [NSProcessInfo initializeWithArguments:argv count:argc environment:env];
#endif

  theApp = [NSApplication sharedApplication];
  [theApp setDelegate: [buttonsController new]];
  {
    NSMenu	*menu = [NSMenu new];

    [menu addItemWithTitle: @"Quit"
		    action: @selector(terminate:)
	     keyEquivalent: @"q"];
    [NSApp setMainMenu: menu];
  }

  [theApp run];

  [pool release];

  return 0;
}
